// SDRxxServerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SDRxxServer.h"
#include "SDRxxServerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define ID_TIMER 5
/////////////////////////////////////////////////////////////////////////////
// CSDRxxServerDlg dialog

CSDRxxServerDlg::CSDRxxServerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSDRxxServerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSDRxxServerDlg)
	m_PortNumber = 50000;
	m_HostIDTxt = _T("");
	m_SNFilterStr = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSDRxxServerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSDRxxServerDlg)
	DDX_Control(pDX, IDC_USB_STATUSTXT, m_USBStatusCtrl);
	DDX_Control(pDX, IDC_SOCKET_STATUSTXT, m_SocketStatusCtrl);
	DDX_Text(pDX, IDC_PORTEDIT, m_PortNumber);
	DDX_Text(pDX, IDC_HOST_IDTXT, m_HostIDTxt);
	DDX_Text(pDX, IDC_SNEDIT, m_SNFilterStr);
	DDV_MaxChars(pDX, m_SNFilterStr, 8);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSDRxxServerDlg, CDialog)
	//{{AFX_MSG_MAP(CSDRxxServerDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_STARTBUTTON, OnStartbutton)
	ON_BN_CLICKED(IDC_STOPBUTTON, OnStopbutton)
	ON_WM_TIMER()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSDRxxServerDlg message handlers

BOOL CSDRxxServerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	m_PortNumber = AfxGetApp()->GetProfileInt("Settings", "Port", 50000);
	m_SNFilterStr = AfxGetApp()->GetProfileString("Settings", "SNFilterStr");

	if(m_SNFilterStr.GetLength() != 8)
		m_SNFilterStr = "";

	m_TimerID = SetTimer(ID_TIMER,500,NULL);
TRACE("\ndlg SNFilter = %s\n\r",m_SNFilterStr);

	m_UsbSocket.StartControl(m_PortNumber,m_SNFilterStr);
	m_Running = TRUE;
	GetDlgItem( IDC_STARTBUTTON )->EnableWindow(FALSE);
	GetDlgItem( IDC_STOPBUTTON )->EnableWindow(TRUE);
	GetDlgItem( IDC_PORTEDIT )->EnableWindow(FALSE);
	GetDlgItem( IDC_SNEDIT )->EnableWindow(FALSE);
	
	int i;
	m_HostIDTxt = m_UsbSocket.GetIPs( i );
	UpdateData(FALSE);
	m_LastConnected = FALSE;

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSDRxxServerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSDRxxServerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

/////////////////////////////////////////////////////////
// called when Start button is pressed
/////////////////////////////////////////////////////////
void CSDRxxServerDlg::OnStartbutton() 
{
	UpdateData(TRUE);
	if(m_SNFilterStr.GetLength() != 8)
	{
		m_SNFilterStr = "";
		UpdateData(FALSE);
	}

	m_UsbSocket.StartControl(m_PortNumber,m_SNFilterStr);
	m_Running = TRUE;
	GetDlgItem( IDC_STARTBUTTON )->EnableWindow(FALSE);
	GetDlgItem( IDC_PORTEDIT )->EnableWindow(FALSE);
	GetDlgItem( IDC_SNEDIT )->EnableWindow(FALSE);
	GetDlgItem( IDC_STOPBUTTON )->EnableWindow(TRUE);
}

/////////////////////////////////////////////////////////
// called when Stop button is pressed
/////////////////////////////////////////////////////////
void CSDRxxServerDlg::OnStopbutton() 
{
	m_UsbSocket.StopControl();
	m_Running = FALSE;
	GetDlgItem( IDC_STARTBUTTON )->EnableWindow(TRUE);
	GetDlgItem( IDC_STOPBUTTON )->EnableWindow(FALSE);
	GetDlgItem( IDC_PORTEDIT )->EnableWindow(TRUE);
	GetDlgItem( IDC_SNEDIT )->EnableWindow(TRUE);
	m_DiscoverServer.Stop();
}

/////////////////////////////////////////////////////////
// called every 500 milliseconds to update status
/////////////////////////////////////////////////////////
void CSDRxxServerDlg::OnTimer(UINT nIDEvent) 
{
BOOL Connected;
	m_USBStatusCtrl.SetWindowText( m_UsbSocket.GetUSBstatus(Connected) );
	m_SocketStatusCtrl.SetWindowText( m_UsbSocket.GetSocketstatus());
	if(Connected != m_LastConnected)
	{
		if(Connected)
		{	//if first connected then start up discover server with latest SDR parameters
			m_DiscoverServer.m_SdrName = m_UsbSocket.m_SdrName;
			m_DiscoverServer.m_SdrSN = m_UsbSocket.m_SdrSN;
			m_DiscoverServer.m_BootVer = m_UsbSocket.m_BootVer;
			m_DiscoverServer.m_FirmVer = m_UsbSocket.m_FirmVer;

			m_DiscoverServer.m_Port =  m_PortNumber;
			m_DiscoverServer.m_IPAdr = m_UsbSocket.m_CurrentIPAddress;
			m_DiscoverServer.Start();
		}
		else
		{
			m_DiscoverServer.Stop();
		}
	}
	m_LastConnected = Connected;
	if(Connected)
	{
		if(m_UsbSocket.IsClientConnected() )
			m_DiscoverServer.m_InUse = TRUE;
		else
			m_DiscoverServer.m_InUse = FALSE;
	}

	CDialog::OnTimer(nIDEvent);
}

void CSDRxxServerDlg::OnClose() 
{
	
	UpdateData(TRUE);
	AfxGetApp()->WriteProfileInt("Settings", "Port", m_PortNumber);
	AfxGetApp()->WriteProfileString("Settings", "SNFilterStr", m_SNFilterStr);
	
	CDialog::OnClose();
}
